<html xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security">
    <head>
        <title>Formulari Gos</title>
        <meta charset="UTF-8"/>
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
    </head>
    <body>
        <div class="container pt-3">
        <header th:replace="~{layout/plantilla :: capcalera}" />

        <h2>Formulari Gos</h2>

        <a th:href="@{/iniciGossos}" class="btn btn-primary">Inici</a>

        <p>
            <!-- Creem un formulari per introduir les dades que rebrà el ControladorInici 
                 i assignarà als atributs del gos passat com a paràmetre en el mètode 
                 crearFormulariGos d'aquest controlador. 
                 Per associar le dades a l'objecte gos, fem servir l'element th:objecte de 
                 Thymeleaf, al qual li assignem com a valor el paràmetre gos del mètode 
                 crearFormulariGos o del mètode editar del controlador.
                 Penseu que fem servir aquest formulari, tant per cear com per modificar un gos-->
        <form th:action="@{/guardarGos}" method="post" th:object="${gos}">

            <!--Thymeleaf indica que una varaible fa refèrencia a un atribut d'una classe de l'aplicació, utilitzant
                l'element precedint el nom th:field. El valor que li assignarem a aquest element serà el nom de
                l'atribut de la classe al que fa referència, per exemple, *{idgos}, fa refèrencia a l'atribut idgos de 
                la classe gos. Fixeu-vos que a diferència de les variables, quan es tracta d'un atribut, les claus de
                l'atribut van precedides de *, en lloc de $.-->

            <!-- Camp ocult on guardem el valor de l'atribut idgos de la classe gos per enviar-lo juntament amb les altres dades.-->                 
            <input type="hidden" name="idgos" th:field="*{idgos}"/>

            <p>
                <label for="nom">Nom:</label> <!--Etiqueta on indiquem a l'usuari que ha d'introduir el nom del gos-->
                <!--Thymeleaf associarà les dades afegides mitjançant aquest input, a l'atribut nom de l'objecte
                    gos assignat a th:objecte-->
                <input type="text" name="nom" th:field="*{nom}"/>
                
                <!--Afegim un contenidor de tipus span per gestionar la validació-->
                <!--Comprovem si el camp "nom" conté errors mitjançant th:if="${#fields.hasErrors('nom')}", on passem com a
                    paràmetre el nom del camp on volem comprovar si hi ha errors, en el nostre cas "nom", i ens retornarà
                    verdader si conté errors i fals en cas contrari.
                    Si conté errors, li demanarem a l'atribut nom del gos que ens mostri els errors mitjançant th:errors="*{nom}".
                    Tot això és possible perquè en la classe Gos hem afegit les anotacions per les validacions.-->
                <div th:if="${#fields.hasErrors('nom')}" th:errors="*{nom}"/>

            </p>

            <p>
                <label for="edat">Edat:</label> <!--Etiqueta per l'edat del gos-->            
                <input type="text" name="edat" th:field="*{edat}"/> <!--Associem les dades introduïdes amb l'atribut edat-->
                <!-- Gestió errors edat-->
                <span th:if="${#fields.hasErrors('edat')}" th:errors="*{edat}"/>
            </p>

            <p>
                <label for="sexe">Sexe:</label> <!--Etiqueta pel sexe del gos-->            
                <input type="text" name="sexe" th:field="*{sexe}"/> <!--Associem les dades introduïdes amb l'atribut sexe-->
                <!-- Gestió errors camp sexe-->
                <span th:if="${#fields.hasErrors('sexe')}" th:errors="*{sexe}"/>
            </p>

            <!-- Botó per enviar les dades-->
            <input type="submit" name="enviar" value="Enviar Dades" class="btn btn-success"/>        
        </form>
        </p>
        
        <!-- Incrustem l'element peu que trobem en layout/plantilla -->
        <footer th:replace="~{layout/plantilla :: peu}" />
        </div>
    </body>
</html>
